OnlineWallet/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from user.views import HomePage

urlpatterns = [
    path('admin/', admin.site.urls),
    path('account/', include('user.urls', namespace='account')),
    path('actions/', include('actions.urls', namespace='actions')),
    path("", HomePage.as_view(), name='home')
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

actions/urls.py
from django.urls import path

from actions.views import IncreaseView, DecreaseView, TransferView

app_name = 'actions'
urlpatterns = [
    path('increase/', IncreaseView.as_view(), name='increase'),
    path('decrease/', DecreaseView.as_view(), name='decrease'),
    path('transfer/', TransferView.as_view(), name='transfer')
]

user/urls.py
from django.urls import path

from user.views import SignUp, VerifyPhoneNumber, LogIn, VerifySMSCode, \
    Profile, LogoutAccount, RepeatLoginVerificationCode, \
    RepeatRegisterVerificationCode

app_name = 'account'
urlpatterns = [
    path('register/', SignUp.as_view(), name='sign_up'),
    path('verify-phone-number', VerifyPhoneNumber.as_view(), name='verify_phone_number'),
    path('login/', LogIn.as_view(), name='login'),
    path("verify-sms-code", VerifySMSCode.as_view(), name='verify_sms_code'),
    path("profile", Profile.as_view(), name="profile"),
    path("logout", LogoutAccount.as_view(), name="logout"),
    path("repeat-login-verification-code/", RepeatLoginVerificationCode.as_view(), name='login_otp'),
    path("repeat-register-verification-code/", RepeatRegisterVerificationCode.as_view(), name='register_otp')
]

actions/models.py
import datetime
import uuid

from django.db import models

from django.utils.translation import ugettext_lazy as _
# Create your models here.
from lib.basemodel import BaseModel


class Transaction(BaseModel):
    INCREASE = '0'
    DECREASE = '1'
    TRANSFER = '2'
    transaction_choices = (
        (INCREASE, "Increase"),
        (DECREASE, "Decrease"),
        (TRANSFER, "Transfer")
    )
    title = models.CharField(_("title"), max_length=32, null=True, blank=True)
    amount = models.IntegerField(_("amount"))
    transaction_type = models.CharField(_("transaction type"), max_length=50, choices=transaction_choices)
    UUID = models.UUIDField(verbose_name=_('uuid'), default=uuid.uuid4)
    user = models.ForeignKey("user.User", verbose_name=_(
        "user id"), on_delete=models.CASCADE, related_name="Transactions")


class Transfer(BaseModel):
    from_user = models.ForeignKey("user.User", verbose_name=_(
        "from user"), on_delete=models.CASCADE, related_name="from_user")
    to_user = models.ForeignKey("user.User", verbose_name=_(
        "to user"), on_delete=models.CASCADE, related_name="to_user")
    transaction = models.ForeignKey("actions.Transaction", verbose_name=_(
        "transaction id"), on_delete=models.CASCADE, related_name="Transfer_transaction")

user/models.py
import datetime

from django.contrib.auth.base_user import AbstractBaseUser
from django.contrib.auth.models import AbstractUser, PermissionsMixin, \
    UserManager
from django.contrib.auth.validators import UnicodeUsernameValidator
from django.core.mail import send_mail
from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.core.validators import RegexValidator
# Create your models here.
from django.utils import timezone

from CreditCard.models import CreditCard


class User(AbstractBaseUser, PermissionsMixin):
    username_validator = UnicodeUsernameValidator()

    username = models.CharField(
        _('username'),
        max_length=150,
        unique=True,
        help_text=_(
            'Required. 150 characters or fewer. Letters, digits and @/./+/-/_ only.'),
        validators=[username_validator],
        error_messages={
            'unique': _("A user with that username already exists."),
        },
    )
    first_name = models.CharField(_('first name'), max_length=30, blank=True)
    last_name = models.CharField(_('last name'), max_length=150, blank=True)
    email = models.EmailField(_('email address'), blank=True)
    phone_regex = RegexValidator(
        regex=r'(\+98|0)?9\d{9}',
        message=_(
            "Phone number must be entered in the format: "
            "'+989999999999' or '09999999999'. Up to 11 digits allowed."
        ))
    phone_number = models.CharField(
        _("phone number"), validators=[phone_regex], max_length=17, unique=True
    )
    credit = models.BigIntegerField(_("credit"), default=0)
    credit_card = models.ForeignKey(
        CreditCard, verbose_name=_("credit card"), on_delete=models.CASCADE,
        related_name="card", null=True, blank=True
    )
    is_staff = models.BooleanField(
        _('staff status'),
        default=False,
        help_text=_(
            'Designates whether the user can log into this admin site.'),
    )
    is_active = models.BooleanField(
        _('active'),
        default=True,
        help_text=_(
            'Designates whether this user should be treated as active. '
            'Unselect this instead of deleting accounts.'
        ),
    )
    date_joined = models.DateTimeField(_('date joined'), default=timezone.now)

    objects = UserManager()

    EMAIL_FIELD = 'email'
    USERNAME_FIELD = 'username'
    REQUIRED_FIELDS = ['email']

    class Meta:
        verbose_name = _('user')
        verbose_name_plural = _('users')

    def clean(self):
        super().clean()
        self.email = self.__class__.objects.normalize_email(self.email)

    def get_full_name(self):
        """
        Return the first_name plus the last_name, with a space in between.
        """
        full_name = '%s %s' % (self.first_name, self.last_name)
        return full_name.strip()

    def get_short_name(self):
        """Return the short name for the user."""
        return self.first_name

    def email_user(self, subject, message, from_email=None, **kwargs):
        """Send an email to this user."""
        send_mail(subject, message, from_email, [self.email], **kwargs)


class UserOTP(models.Model):
    SIGNUP = 1
    LOGIN = 2
    CODE_TYPE_CHOICES = (
        (SIGNUP, "sign_up"),
        (LOGIN, 'login')
    )
    code = models.CharField(verbose_name=_('code'), max_length=6)
    expire_time_start = models.DateTimeField(verbose_name=_("start of expire time"), default=datetime.datetime.now, null=True)
    expire_time_end = models.DateTimeField(_("end of expire time"), null=True)
    code_type = models.IntegerField(_("code type"), choices=CODE_TYPE_CHOICES, null=True)
    phone_number = models.CharField(_('phone number'), max_length=11, null=True)

    def time_in_range(self, start, end, x):
        """Return true if x is in the range [start, end]"""
        if start <= end:
            return start <= x <= end
        else:
            return start <= x or x <= end

user/forms.py
from django import forms
from django.contrib.auth import get_user_model, login
from django.utils.translation import ugettext_lazy as _
import datetime

from user.authentication import PhoneNumberBackend
from user.models import UserOTP

User = get_user_model()


class SignUpForm(forms.Form):
    username = forms.CharField()
    first_name = forms.CharField()
    last_name = forms.CharField()
    email = forms.EmailField()
    phone_number = forms.CharField()
    password = forms.CharField()
    repeat_password = forms.CharField()

    def clean(self):
        user = User.objects.filter(
            username=self.cleaned_data["username"],
            phone_number=self.cleaned_data["phone_number"]).first()
        if user is not None:
            raise forms.ValidationError(_(
                "User with these provided data exist \n Try with another Phone Number")
            )
        if self.cleaned_data['password'] != self.cleaned_data["repeat_password"]:
            raise forms.ValidationError('Passwords are not equal together')
        return self.cleaned_data


class VerifyPhoneNumberForm(forms.Form):
    sms_code = forms.CharField(required=True, widget=forms.PasswordInput, label="Enter The Code")

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop('request', None)
        self.backend_authenticate = "user.authentication.PhoneNumberBackend"
        super().__init__(*args, **kwargs)

    def clean(self):
        if self.cleaned_data['sms_code'] is None:
            raise forms.ValidationError(_("This field is required"))

        user_code = UserOTP.objects.filter(
            code_type=UserOTP.SIGNUP,
            phone_number=self.request.session['phone_number']).last()
        user_code_expire_time = user_code.time_in_range(
            user_code.expire_time_start, user_code.expire_time_end,
            datetime.datetime.now()
        )
        if self.cleaned_data['sms_code'] != user_code.code:
            raise forms.ValidationError(_("This code is not True"))
        if user_code_expire_time is False:
            raise forms.ValidationError(_('This code is expired'))
        return self.cleaned_data

    def save(self, request):
        user = User.objects.create_user(
            username=request.session['data']['username'],
            first_name=request.session['data']['first_name'],
            last_name=request.session['data']['last_name'],
            email=request.session['data']['email'],
            phone_number=request.session['data']['phone_number'],
            password=request.session['data']['password']
        )
        user = PhoneNumberBackend.authenticate(
            self, request=self.request,
            phone_number=self.request.session["phone_number"]
        )
        login(self.request, user, backend=self.backend_authenticate)
        return user


class LoginForm(forms.Form):
    phone_number = forms.CharField(required=True)

    def clean(self):
        if self.cleaned_data['phone_number'] is None:
            raise forms.ValidationError(_("Phone number is required"))
        user = User.objects.filter(
            phone_number=self.cleaned_data['phone_number']).first()
        if user is None:
            raise forms.ValidationError(_
                ("User with this phone number does not exist")
            )
        return self.cleaned_data


class VerifySMSCodeForm(forms.Form):
    sms_code = forms.CharField(
        required=True, #widget=forms.PasswordInput,
        label="Enter the code which has sent"
    )

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop('request', None)
        self.backend_authenticate = "user.authentication.PhoneNumberBackend"
        super().__init__(*args, **kwargs)

    def clean(self):
        user_code = UserOTP.objects.filter(code_type=UserOTP.LOGIN,
            phone_number=self.request.session['phone_number']).last()

        user_code_expire_time = user_code.time_in_range(
            user_code.expire_time_start, user_code.expire_time_end,
            datetime.datetime.now()
        )
        if self.cleaned_data['sms_code'] != user_code.code:
            raise forms.ValidationError(_("This code is not True"))
        if user_code_expire_time is False:
            raise forms.ValidationError(_('This code is expired'))
        return self.cleaned_data

    def sign_in(self):
        user = PhoneNumberBackend.authenticate(
            self, request=self.request,
            phone_number=self.request.session["phone_number"]
        )
        login(self.request, user, backend=self.backend_authenticate)
        return user

user/views.py
import datetime

from django import forms
from django.conf import settings
from django.contrib.auth import login, get_user_model
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.views import LogoutView
from django.http import HttpResponseRedirect
from django.shortcuts import render

# Create your views here.
from django.urls import reverse_lazy, reverse
from django.utils.crypto import get_random_string
from django.views.generic import FormView
from django.views.generic.base import View, TemplateView, RedirectView

from user.authentication import PhoneNumberBackend
from user.forms import SignUpForm, VerifyPhoneNumberForm, LoginForm, \
    VerifySMSCodeForm
from user.models import UserOTP
from user.tasks import send_verification_sms


User = get_user_model()


class SignUp(FormView):
    form_class = SignUpForm
    template_name = 'user/sign_up.html'

    def form_valid(self, form):
        phone_number = form.cleaned_data["phone_number"]
        code = get_random_string(length=6, allowed_chars="0123456789abcdef")
        OTP_code = UserOTP.objects.create(
            code=code, code_type=UserOTP.SIGNUP,
            expire_time_end=(datetime.datetime.now()+datetime.timedelta(minutes=1)),
            phone_number=phone_number
        )
        self.request.session['phone_number'] = phone_number
        self.request.session['code'] = code
        self.request.session['data'] = form.cleaned_data
        send_verification_sms.delay(phone_number, code)
        return HttpResponseRedirect(reverse('account:verify_phone_number'))


class VerifyPhoneNumber(FormView):
    form_class = VerifyPhoneNumberForm
    template_name = 'user/verify_signup_code.html'
    success_url = reverse_lazy('account:profile')

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs.update({
            'request': self.request
        })
        return kwargs

    def form_valid(self, form):
        form.save(self.request)
        del self.request.session['data']
        del self.request.session['code']
        return super().form_valid(form)


class LogIn(FormView):
    form_class = LoginForm
    template_name = 'user/login.html'

    def form_valid(self, form):
        phone_number = form.cleaned_data["phone_number"]
        code = get_random_string(length=6, allowed_chars="0123456789abcdef")
        OTP_code = UserOTP.objects.create(
            code=code, code_type=UserOTP.LOGIN,
            expire_time_end=(datetime.datetime.now() + datetime.timedelta(
                minutes=1)),
            phone_number=phone_number
        )
        self.request.session["phone_number"] = phone_number
        self.request.session["sms_verify_code"] = code
        send_verification_sms.delay(phone_number, code)
        return HttpResponseRedirect(reverse('account:verify_sms_code'))


class VerifySMSCode(FormView):
    form_class = VerifySMSCodeForm
    template_name = 'user/verify_sms_code.html'
    success_url = reverse_lazy('account:profile')
    backend_authenticate = "user.authentication.PhoneNumberBackend"

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs.update({
            'request': self.request
        })
        return kwargs

    def form_valid(self, form):
        form.sign_in()
        del self.request.session['sms_verify_code']
        del self.request.session["phone_number"]
        return super().form_valid(form)


class RepeatRegisterVerificationCode(RedirectView):
    url = reverse_lazy('account:verify_phone_number')

    def get(self, request, *args, **kwargs):

        code = get_random_string(length=6, allowed_chars="0123456789abcdef")
        OTP = UserOTP.objects.create(
            code=code,
            expire_time_end=(datetime.datetime.now() + datetime.timedelta(
                minutes=1)), code_type=UserOTP.SIGNUP,
            phone_number=request.session['phone_number']
        )
        send_verification_sms.delay(request.session['phone_number'], code)
        return super().get(request, *args, **kwargs)


class RepeatLoginVerificationCode(RedirectView):
    url = reverse_lazy('account:verify_sms_code')

    def get(self, request, *args, **kwargs):
        code = get_random_string(length=6, allowed_chars="0123456789abcdef")
        OTP = UserOTP.objects.create(
            code=code,
            expire_time_end=(datetime.datetime.now() + datetime.timedelta(
                minutes=1)), code_type=UserOTP.LOGIN,
            phone_number=request.session['phone_number']
        )
        send_verification_sms.delay(request.session['phone_number'], code)
        return super().get(request, *args, **kwargs)


class Profile(LoginRequiredMixin, View):
    login_url = settings.LOGIN_URL

    def get_object(self):
        user = User.objects.select_related("credit_card").prefetch_related("Transactions", "from_user").get(pk=self.request.user.id)
        return user

    def get(self, request):
        context = dict()
        user = self.get_object()
        transaction = user.Transactions.prefetch_related("Transfer_transaction")
        transfer = user.from_user.filter(from_user=user) | user.from_user.filter(from_user=user)
        #transfer = transaction.Transfer_transaction.filter(from_user=user)|transaction.Transfer_transaction.filter(to_user=user)
        context['first_name'] = user.first_name
        context['last_name'] = user.last_name
        context['credit'] = user.credit
        context['phone_number'] = user.phone_number
        context["credit_card"] = user.credit_card
        context["transaction"] = transaction
        context["transfer"] = transfer

        return render(request, 'user/profile.html', context=context)


class LogoutAccount(LogoutView):
    next_page = reverse_lazy('home')


class HomePage(TemplateView):
    template_name = "home.html"

templates/user/login.html
{% extends 'baseform.html' %}

{% load crispy_forms_tags %}

{% block title %} Login {% endblock %}

{% block title2 %} Login Form {% endblock %}

{% block content %}
<form method="post" novalidate enctype='multipart/form-data' >
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success">Login</button>
  </form>
{% endblock %}

templates/user/logout.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Logout</title>
</head>
<body>
    <h3>You are Logged Out</h3>
</body>
</html>

templates/user/profile.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
<title>Profile</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<link type="text/css" rel="stylesheet" href="{% static 'user/css/stylesheet.css'%}"/>
<script src="{% static 'user/js/profile.js' %}"></script>

</head>
<body>

<h2>Profile Page</h2>
<p>Click on the buttons inside the tabbed menu:</p>

<div class="tab">
  <button class="tablinks" onclick="openTab(event, 'UserData')">User Data</button>
  <button class="tablinks" onclick="openTab(event, 'Actions')">Actions</button>
  <button class="tablinks" onclick="openTab(event, 'Card')">Cards</button>
</div>

<div id="UserData" class="tabcontent">
  <h3>First Name: {{first_name}}</h3>
  <h3>Last Name: {{last_name}}</h3>
  <h3> Credit: {{credit}} Rials</h3>
  <h3> Phone Number: {{phone_number}}</h3>

</div>

<div id="Actions" class="tabcontent"  style="font-size: 20px">
  <h3>Transaction History: </h3>
  <form action="{% url 'actions:increase' %}" method="get" target="_blank">
  <button class="button" style="vertical-align:middle" type="submit" id="increase"><span>Increase </span></button>
  </form>
  <form action="{% url 'actions:decrease' %}" method="get" target="_blank">
  <button class="button" style="vertical-align:middle" type="submit" id="decrease"><span>Decrease </span></button>
  </form>
  <form action="{% url 'actions:transfer' %}" method="get" target="_blank">
  <button class="button" style="vertical-align:middle" type="submit" id="transfer"><span>Transfer </span></button>
  </form>
  {% for transaction in transaction %}
  <ul>
  <li>{{transaction.title|default:"No title"}}<br>Amount: {{transaction.amount}}
    <br> Transaction Type: {{transaction.get_transaction_type_display}}</li>
    </ul>
  {% endfor %}
</div>

<div id="Card" class="tabcontent">
    <h3>Credit Cards:</h3>
    <ul>
  <li>{{credit_card}}</li>
    </ul>
</div>
</body>
</html>

templates/user/sign_up.html
{% extends 'baseform.html' %}

{% load crispy_forms_tags %}

{% block title %} Sign Up {% endblock %}

{% block title2 %} Sign Up {% endblock %}

{% block content %}
<form method="post" novalidate enctype='multipart/form-data' >
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success">Sign Up</button>
  </form>
{% endblock %}

templates/user/verify_signup_code.html
{% extends 'baseform.html' %}

{% load crispy_forms_tags %}

{% block title %} Verify Phone Number {% endblock %}

{% block title2 %} Verify Phone Number {% endblock %}

{% block content %}
  <form method="post" novalidate>
    {% csrf_token %}
    <div class="row">
      <div class="col-6">
        {{ form|crispy }}
      </div>
    <button type="submit" class="btn btn-success">Sign Up</button>
  </form>
<form action="{% url 'account:register_otp' %}">
    <label>If you did not receive the code after 1 minute or it is expired, click on the button:</label>
    <input type="submit" value="Send another code" style="background-color: #008CBA; border: none; color: white; padding: 15px 32px; text-align: center; text-decoration: none; display: inline-block; font-size: 16px; margin: 4px 2px; cursor: pointer;"/>
</form>
{% endblock %}

templates/user/verify_sms_code.html
{% extends 'baseform.html' %}

{% load crispy_forms_tags %}

{% block title %} Verify Page {% endblock %}

{% block title2 %} Verify Phone Number {% endblock %}

{% block content %}
<form method="post" novalidate enctype='multipart/form-data' >
    {% csrf_token %}
    {{ form|crispy }}
    <button type="submit" class="btn btn-success">Login</button>
    <h3><a href="{% url 'account:login_otp' %}"></a></h3>
  </form>
<form action="{% url 'account:login_otp' %}">
    <label>If you did not receive the code after 1 minute or it is expired, click on the button:</label>
    <input type="submit" value="Send another code" style="background-color: #008CBA; border: none; color: white; padding: 15px 32px; text-align: center; text-decoration: none; display: inline-block; font-size: 16px; margin: 4px 2px; cursor: pointer;"/>
</form>
{% endblock %}